您的位置:首页 > 其它

HDU 1054 Strategic Game(二分图最小点覆盖 或者 树形DP)

2016-09-05 23:11 656 查看
描述:

Strategic Game

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 1760    Accepted Submission(s): 742


Problem Description
Bob enjoys playing computer games, especially strategic games, but sometimes he cannot find the solution fast enough and then he is very sad. Now he has the following problem. He must defend a medieval city, the roads of which form
a tree. He has to put the minimum number of soldiers on the nodes so that they can observe all the edges. Can you help him?

Your program should find the minimum number of soldiers that Bob has to put for a given tree.

The input file contains several data sets in text format. Each data set represents a tree with the following description:

the number of nodes

the description of each node in the following format

node_identifier:(number_of_roads) node_identifier1 node_identifier2 ... node_identifier

or

node_identifier:(0)

The node identifiers are integer numbers between 0 and n-1, for n nodes (0 < n <= 1500). Every edge appears only once in the input data.

For example for the tree:



the solution is one soldier ( at the node 1).

The output should be printed on the standard output. For each given input data set, print one integer number in a single line that gives the result (the minimum number of soldiers). An example is given in the following table:
 

Sample Input

4
0:(1) 1
1:(2) 2 3
2:(0)
3:(0)
5
3:(3) 1 4 2
1:(1) 0
2:(0)
0:(0)
4:(0)

 

Sample Output

1
2

思路:
就是要找最小点覆盖。

一个二分图中的最大匹配数等于这个图中的最小点覆盖数

但这我们要扩展结点为n-n的匹配,无向图。

因为遍历所有的点, 多了一半,所以就是二分匹配数除于2就是答案了。

貌似还能用树状DP来做,待学习

代码一:

//G++  764ms  1752K
//用STL中的vector建立邻接表实现匈牙利算法
#include<bits/stdc++.h>
using namespace std;

const int maxn=1555;
int link[maxn];
bool used[maxn];
vector<int>G[maxn];
int uN;
bool dfs(int u){
for(int i=0;i<G[u].size();i++){
if(!used[G[u][i]]){
used[G[u][i]]=true;
if(link[G[u][i]]==-1||dfs(link[G[u][i]])){
link[G[u][i]]=u;
return true;
}
}
}
return false;
}

int hungary(){
int u;
int res=0;
memset(link,-1,sizeof(link));
for(u=0;u<uN;u++){
memset(used,false,sizeof(used));
if(dfs(u)) res++;
}
return res;
}

int main(){
int n,u,k,v;
while(~scanf("%d",&n)){
for(int i=0; i<maxn; i++)G[i].clear();
for(int i=0; i<n; i++){
scanf("%d:(%d)",&u,&k);
while(k--){
scanf("%d",&v);
G[u].push_back(v);
G[v].push_back(u);
}
}
uN=n;
printf("%d\n",hungary()/2);//因为遍历所有的点  多了一半
}
return 0;
}




代码二:


(用vector建立邻接表实现的匈牙利算法效率比下面的HC算法效率高)

//G++  4274ms  11100K
#include<bits/stdc++.h>
using namespace std;

/* *********************************************
二分图匹配(Hopcroft-Carp的算法)。
初始化(建边):g[][]邻接矩阵
调用:res=MaxMatch();  Nx,Ny要初始化!!!
时间复杂大为 O(sqrt(V)*E)

适用于数据较大的二分匹配
需要queue头文件
********************************************** */
const int maxn=1555;
const int inf=1<<28;
int g[maxn][maxn],Mx[maxn],My[maxn],Nx,Ny;
int dx[maxn],dy[maxn],dis;
bool vis[maxn];

bool searchP(){
queue<int>Q;
dis=inf;
memset(dx,-1,sizeof(dx));
memset(dy,-1,sizeof(dy));
for(int i=0;i<Nx;i++)
if(Mx[i]==-1){
Q.push(i);
dx[i]=0;
}
while(!Q.empty()){
int u=Q.front();
Q.pop();
if(dx[u]>dis)  break;
for(int v=0;v<Ny;v++)
if(g[u][v]&&dy[v]==-1){
dy[v]=dx[u]+1;
if(My[v]==-1)  dis=dy[v];
else
{
dx[My[v]]=dy[v]+1;
Q.push(My[v]);
}
}
}
return dis!=inf;
}

bool dfs(int u){
for(int v=0;v<Ny;v++)
if(!vis[v]&&g[u][v]&&dy[v]==dx[u]+1)
{
vis[v]=1;
if(My[v]!=-1&&dy[v]==dis) continue;
if(My[v]==-1||dfs(My[v]))
{
My[v]=u;
Mx[u]=v;
return 1;
}
}
return 0;
}

int MaxMatch(){
int res=0;
memset(Mx,-1,sizeof(Mx));
memset(My,-1,sizeof(My));
while(searchP())
{
memset(vis,0,sizeof(vis));
for(int i=0;i<Nx;i++)
if(Mx[i]==-1 && dfs(i))  res++;
}
return res;
}

int  main(){
int n,u,k,v;
while(~scanf("%d",&n)){
memset(g, 0, sizeof(g));
for(int i=0; i<n; i++){
scanf("%d:(%d)",&u,&k);
while(k--){
scanf("%d",&v);
g[u][v]=1;
g[v][u]=1;
}
}
Nx=Ny=n;
printf("%d\n",MaxMatch()/2);//因为遍历所有的点  多了一半
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: